diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/ap-wifi-mac.h ns-3.42/src/wifi/model/ap-wifi-mac.h
--- ns-3.41/src/wifi/model/ap-wifi-mac.h	2024-02-09 14:44:08.577794800 -0800
+++ ns-3.42/src/wifi/model/ap-wifi-mac.h	2024-05-29 15:29:47.196073800 -0700
@@ -25,6 +25,10 @@
 #include "wifi-mac-header.h"
 #include "wifi-mac.h"
 
+#include "ns3/attribute-container.h"
+#include "ns3/enum.h"
+#include "ns3/pair.h"
+
 #include <unordered_map>
 #include <variant>
 
@@ -59,7 +63,11 @@
  * \ingroup wifi
  *
  * Handle association, dis-association and authentication,
- * of STAs within an infrastructure BSS.
+ * of STAs within an infrastructure BSS.  By default, beacons are
+ * sent with PIFS access, zero backoff, and are generated roughly
+ * every 102.4 ms by default (configurable by an attribute) and
+ * with some jitter to de-synchronize beacon transmissions in
+ * multi-BSS scenarios.
  */
 class ApWifiMac : public WifiMac
 {
@@ -79,7 +87,7 @@
     void Enqueue(Ptr<Packet> packet, Mac48Address to, Mac48Address from) override;
     bool SupportsSendFrom() const override;
     Ptr<WifiMacQueue> GetTxopQueue(AcIndex ac) const override;
-    void ConfigureStandard(WifiStandard standard) override;
+    int64_t AssignStreams(int64_t stream) override;
 
     /**
      * \param interval the interval between two beacon transmissions.
@@ -91,17 +99,6 @@
     Time GetBeaconInterval() const;
 
     /**
-     * Assign a fixed random variable stream number to the random variables
-     * used by this model.  Return the number of streams (possibly zero) that
-     * have been assigned.
-     *
-     * \param stream first stream index to use
-     *
-     * \return the number of stream indices assigned by this model
-     */
-    int64_t AssignStreams(int64_t stream);
-
-    /**
      * Get a const reference to the map of associated stations on the given link.
      * Each station is specified by an (association ID, MAC address) pair. Make sure
      * not to use the returned reference after that this object has been deallocated.
@@ -171,6 +168,65 @@
      */
     uint8_t GetMaxBufferStatus(Mac48Address address) const;
 
+    /// ACI-indexed map of access parameters of type unsigned integer (CWmin, CWmax and AIFSN)
+    using UintAccessParamsMap = std::map<AcIndex, std::vector<uint64_t>>;
+
+    /// ACI-indexed map of access parameters of type Time (TxopLimit)
+    using TimeAccessParamsMap = std::map<AcIndex, std::vector<Time>>;
+
+    /// AttributeValue type of a pair (ACI, access parameters of type unsigned integer)
+    using UintAccessParamsPairValue =
+        PairValue<EnumValue<AcIndex>, AttributeContainerValue<UintegerValue, ',', std::vector>>;
+
+    /// AttributeValue type of a pair (ACI, access parameters of type Time)
+    using TimeAccessParamsPairValue =
+        PairValue<EnumValue<AcIndex>, AttributeContainerValue<TimeValue, ',', std::vector>>;
+
+    /// AttributeValue type of an ACI-indexed map of access parameters of type unsigned integer
+    using UintAccessParamsMapValue = AttributeContainerValue<UintAccessParamsPairValue, ';'>;
+
+    /// AttributeValue type of ACI-indexed map of access parameters of type Time
+    using TimeAccessParamsMapValue = AttributeContainerValue<TimeAccessParamsPairValue, ';'>;
+
+    /**
+     * Get a checker for the CwMinsForSta, CwMaxsForSta and AifsnsForSta attributes, which can
+     * be used to deserialize an ACI-indexed map of access parameters of type unsigned integer
+     * (CWmin, CWmax and AIFSN) from a string:
+     *
+     * \code
+     *   ApWifiMac::UintAccessParamsMapValue value;
+     *   value.DeserializeFromString("BE 31,31; VO 15,15",
+     *                               ApWifiMac::GetUintAccessParamsChecker<uint32_t>());
+     *   auto map = value.Get();
+     * \endcode
+     *
+     * The type of \p map is ApWifiMac::UintAccessParamsMapValue::result_type, which is
+     * std::list<std::pair<AcIndex, std::vector<uint64_t>>>.
+     *
+     * \tparam T \explicit the type of the unsigned integer access parameter
+     * \return a checker for the CwMinsForSta, CwMaxsForSta and AifsnsForSta attributes
+     */
+    template <class T>
+    static Ptr<const AttributeChecker> GetUintAccessParamsChecker();
+
+    /**
+     * Get a checker for the TxopLimitsForSta attribute, which can be used to deserialize an
+     * ACI-indexed map of access parameters of type Time (TxopLimit) from a string:
+     *
+     * \code
+     *   ApWifiMac::TimeAccessParamsMapValue value;
+     *   value.DeserializeFromString("BE 3200us; VO 3232us",
+     *                               ApWifiMac::GetTimeAccessParamsChecker());
+     *   auto map = value.Get();
+     * \endcode
+     *
+     * The type of \p map is ApWifiMac::TimeAccessParamsMapValue::result_type, which is
+     * std::list<std::pair<AcIndex, std::vector<Time>>>.
+     *
+     * \return a checker for the TxopLimitsForSta attribute
+     */
+    static Ptr<const AttributeChecker> GetTimeAccessParamsChecker();
+
   protected:
     /**
      * Structure holding information specific to a single link. Here, the meaning of
@@ -209,6 +265,7 @@
     std::unique_ptr<LinkEntity> CreateLinkEntity() const override;
     Mac48Address DoGetLocalAddress(const Mac48Address& remoteAddr) const override;
     void Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
+    void DoCompleteConfig() override;
 
     /**
      * Check whether the supported rate set included in the received (Re)Association
@@ -356,6 +413,22 @@
     void SendOneBeacon(uint8_t linkId);
 
     /**
+     * Get the FILS Discovery frame to send on the given link.
+     *
+     * \param linkId the ID of the given link
+     * \return the FILS Discovery frame to send on the given link
+     */
+    Ptr<WifiMpdu> GetFilsDiscovery(uint8_t linkId) const;
+
+    /**
+     * Schedule the transmission of FILS Discovery frames or unsolicited Probe Response frames
+     * on the given link
+     *
+     * \param linkId the ID of the given link
+     */
+    void ScheduleFilsDiscOrUnsolProbeRespFrames(uint8_t linkId);
+
+    /**
      * Process the Power Management bit in the Frame Control field of an MPDU
      * successfully received on the given link.
      *
@@ -528,6 +601,17 @@
     /// transition timeout events running for EMLSR clients
     std::map<Mac48Address, EventId> m_transitionTimeoutEvents;
 
+    UintAccessParamsMap m_cwMinsForSta;     //!< Per-AC CW min values to advertise to stations
+    UintAccessParamsMap m_cwMaxsForSta;     //!< Per-AC CW max values to advertise to stations
+    UintAccessParamsMap m_aifsnsForSta;     //!< Per-AC AIFS values to advertise to stations
+    TimeAccessParamsMap m_txopLimitsForSta; //!< Per-AC TXOP limits values to advertise to stations
+
+    Time m_fdBeaconInterval6GHz;    //!< Time elapsing between a beacon and FILS Discovery (FD)
+                                    //!< frame or between two FD frames on 6GHz links
+    Time m_fdBeaconIntervalNon6GHz; //!< Time elapsing between a beacon and FILS Discovery (FD)
+                                    //!< frame or between two FD frames on 2.4GHz and 5GHz links
+    bool m_sendUnsolProbeResp;      //!< send unsolicited Probe Response instead of FILS Discovery
+
     /// store value and timestamp for each Buffer Status Report
     struct BsrType
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/block-ack-manager.cc ns-3.42/src/wifi/model/block-ack-manager.cc
--- ns-3.41/src/wifi/model/block-ack-manager.cc	2024-02-09 14:44:08.577794800 -0800
+++ ns-3.42/src/wifi/model/block-ack-manager.cc	2024-05-29 15:29:47.196073800 -0700
@@ -99,11 +99,11 @@
 
 void
 BlockAckManager::CreateOriginatorAgreement(const MgtAddBaRequestHeader& reqHdr,
-                                           const Mac48Address& recipient,
-                                           bool htSupported)
+                                           const Mac48Address& recipient)
 {
-    NS_LOG_FUNCTION(this << reqHdr << recipient << htSupported);
-    const uint8_t tid = reqHdr.GetTid();
+    NS_LOG_FUNCTION(this << reqHdr << recipient);
+    const auto tid = reqHdr.GetTid();
+
     OriginatorBlockAckAgreement agreement(recipient, tid);
     agreement.SetStartingSequence(reqHdr.GetStartingSequence());
     /* For now we assume that originator doesn't use this field. Use of this field
@@ -111,7 +111,7 @@
     agreement.SetBufferSize(reqHdr.GetBufferSize());
     agreement.SetTimeout(reqHdr.GetTimeout());
     agreement.SetAmsduSupport(reqHdr.IsAmsduSupported());
-    agreement.SetHtSupported(htSupported);
+    agreement.SetHtSupported(true);
     if (reqHdr.IsImmediateBlockAck())
     {
         agreement.SetImmediateBlockAck();
@@ -195,11 +195,10 @@
 BlockAckManager::CreateRecipientAgreement(const MgtAddBaResponseHeader& respHdr,
                                           const Mac48Address& originator,
                                           uint16_t startingSeq,
-                                          bool htSupported,
                                           Ptr<MacRxMiddle> rxMiddle)
 {
-    NS_LOG_FUNCTION(this << respHdr << originator << startingSeq << htSupported << rxMiddle);
-    uint8_t tid = respHdr.GetTid();
+    NS_LOG_FUNCTION(this << respHdr << originator << startingSeq << rxMiddle);
+    const auto tid = respHdr.GetTid();
 
     RecipientBlockAckAgreement agreement(originator,
                                          respHdr.IsAmsduSupported(),
@@ -207,7 +206,8 @@
                                          respHdr.GetBufferSize(),
                                          respHdr.GetTimeout(),
                                          startingSeq,
-                                         htSupported);
+                                         true);
+
     agreement.SetMacRxMiddle(rxMiddle);
     if (respHdr.IsImmediateBlockAck())
     {
@@ -450,7 +450,7 @@
     uint16_t nSuccessfulMpdus = 0;
     uint16_t nFailedMpdus = 0;
 
-    if (it->second.first.m_inactivityEvent.IsRunning())
+    if (it->second.first.m_inactivityEvent.IsPending())
     {
         /* Upon reception of a BlockAck frame, the inactivity timer at the
             originator must be reset.
@@ -532,7 +532,7 @@
     {
         // MPDUs that were transmitted on another link shall stay inflight
         auto linkIds = (*mpduIt)->GetInFlightLinkIds();
-        if (linkIds.count(linkId) == 0)
+        if (!linkIds.contains(linkId))
         {
             mpduIt = HandleInFlightMpdu(linkId, mpduIt, STAY_INFLIGHT, it, now);
             continue;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/block-ack-manager.h ns-3.42/src/wifi/model/block-ack-manager.h
--- ns-3.41/src/wifi/model/block-ack-manager.h	2024-02-09 14:44:08.577794800 -0800
+++ ns-3.42/src/wifi/model/block-ack-manager.h	2024-05-29 15:29:47.196073800 -0700
@@ -106,14 +106,12 @@
     /**
      * \param reqHdr Relative Add block ack request (action frame).
      * \param recipient Address of peer station involved in block ack mechanism.
-     * \param htSupported Whether both originator and recipient support HT
      *
      * Creates a new originator block ack agreement in pending state. When a ADDBA response
      * with a successful status code is received, the relative agreement becomes established.
      */
     void CreateOriginatorAgreement(const MgtAddBaRequestHeader& reqHdr,
-                                   const Mac48Address& recipient,
-                                   bool htSupported = true);
+                                   const Mac48Address& recipient);
     /**
      * \param recipient Address of peer station involved in block ack mechanism.
      * \param tid traffic ID of transmitted packet.
@@ -140,7 +138,6 @@
      *        mechanism.
      * \param startingSeq Sequence number of the first MPDU of all
      *        packets for which block ack was negotiated.
-     * \param htSupported whether HT support is enabled
      * \param rxMiddle the MAC RX Middle on this station
      *
      * This function is typically invoked only by ns3::WifiMac
@@ -153,7 +150,6 @@
     void CreateRecipientAgreement(const MgtAddBaResponseHeader& respHdr,
                                   const Mac48Address& originator,
                                   uint16_t startingSeq,
-                                  bool htSupported,
                                   Ptr<MacRxMiddle> rxMiddle);
     /**
      * Destroy a recipient Block Ack agreement.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/channel-access-manager.cc ns-3.42/src/wifi/model/channel-access-manager.cc
--- ns-3.41/src/wifi/model/channel-access-manager.cc	2024-02-09 14:44:08.577794800 -0800
+++ ns-3.42/src/wifi/model/channel-access-manager.cc	2024-05-29 15:29:47.196073800 -0700
@@ -313,7 +313,7 @@
                                                uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << phy << channel << linkId);
-    NS_ASSERT_MSG(m_switchingEmlsrLinks.count(phy) == 0,
+    NS_ASSERT_MSG(!m_switchingEmlsrLinks.contains(phy),
                   "The given PHY is already expected to switch channel");
     m_switchingEmlsrLinks.emplace(phy, EmlsrLinkSwitchInfo{channel, linkId});
 }
@@ -733,7 +733,7 @@
     {
         NS_LOG_DEBUG("expected backoff end=" << expectedBackoffEnd);
         Time expectedBackoffDelay = expectedBackoffEnd - Simulator::Now();
-        if (m_accessTimeout.IsRunning() &&
+        if (m_accessTimeout.IsPending() &&
             Simulator::GetDelayLeft(m_accessTimeout) > expectedBackoffDelay)
         {
             m_accessTimeout.Cancel();
@@ -976,7 +976,7 @@
     InitLastBusyStructs();
 
     // Cancel timeout
-    if (m_accessTimeout.IsRunning())
+    if (m_accessTimeout.IsPending())
     {
         m_accessTimeout.Cancel();
     }
@@ -1015,7 +1015,7 @@
     NS_LOG_FUNCTION(this);
     m_sleeping = true;
     // Cancel timeout
-    if (m_accessTimeout.IsRunning())
+    if (m_accessTimeout.IsPending())
     {
         m_accessTimeout.Cancel();
     }
@@ -1033,7 +1033,7 @@
     NS_LOG_FUNCTION(this);
     m_off = true;
     // Cancel timeout
-    if (m_accessTimeout.IsRunning())
+    if (m_accessTimeout.IsPending())
     {
         m_accessTimeout.Cancel();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/eht/default-emlsr-manager.cc ns-3.42/src/wifi/model/eht/default-emlsr-manager.cc
--- ns-3.41/src/wifi/model/eht/default-emlsr-manager.cc	2024-02-09 14:44:08.581795000 -0800
+++ ns-3.42/src/wifi/model/eht/default-emlsr-manager.cc	2024-05-29 15:29:47.196073800 -0700
@@ -19,6 +19,8 @@
 
 #include "default-emlsr-manager.h"
 
+#include "eht-frame-exchange-manager.h"
+
 #include "ns3/boolean.h"
 #include "ns3/channel-access-manager.h"
 #include "ns3/log.h"
@@ -161,13 +163,14 @@
         }
         else
         {
-            Simulator::Schedule(mainPhy->GetDelayUntilIdle(),
-                                &DefaultEmlsrManager::SwitchMainPhy,
-                                this,
-                                GetMainPhyId(),
-                                false,
-                                DONT_RESET_BACKOFF,
-                                REQUEST_ACCESS);
+            Simulator::Schedule(mainPhy->GetDelayUntilIdle(), [=, this]() {
+                // request the main PHY to switch back to the primary link only if in the meantime
+                // no TXOP started on another link (which will require the main PHY to switch link)
+                if (!GetEhtFem(linkId)->UsingOtherEmlsrLink())
+                {
+                    SwitchMainPhy(GetMainPhyId(), false, DONT_RESET_BACKOFF, REQUEST_ACCESS);
+                }
+            });
         }
         return;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/eht/eht-configuration.cc ns-3.42/src/wifi/model/eht/eht-configuration.cc
--- ns-3.41/src/wifi/model/eht/eht-configuration.cc	2024-02-09 14:44:08.581795000 -0800
+++ ns-3.42/src/wifi/model/eht/eht-configuration.cc	2024-05-29 15:29:47.200073700 -0700
@@ -36,6 +36,21 @@
 
 NS_OBJECT_ENSURE_REGISTERED(EhtConfiguration);
 
+std::ostream&
+operator<<(std::ostream& os, WifiTidToLinkMappingNegSupport negsupport)
+{
+    switch (negsupport)
+    {
+    case WifiTidToLinkMappingNegSupport::NOT_SUPPORTED:
+        return os << "NOT_SUPPORTED";
+    case WifiTidToLinkMappingNegSupport::SAME_LINK_SET:
+        return os << "SAME_LINK_SET";
+    case WifiTidToLinkMappingNegSupport::ANY_LINK_SET:
+        return os << "ANY_LINK_SET";
+    };
+    return os << "UNKNOWN(" << static_cast<uint32_t>(negsupport) << ")";
+}
+
 EhtConfiguration::EhtConfiguration()
 {
     NS_LOG_FUNCTION(this);
@@ -94,19 +109,17 @@
                 UintegerValue(DEFAULT_MSD_MAX_N_TXOPS),
                 MakeUintegerAccessor(&EhtConfiguration::m_msdMaxNTxops),
                 MakeUintegerChecker<uint8_t>(0, 15))
-            .AddAttribute(
-                "TidToLinkMappingNegSupport",
-                "TID-to-Link Mapping Negotiation Support.",
-                EnumValue(WifiTidToLinkMappingNegSupport::WIFI_TID_TO_LINK_MAPPING_ANY_LINK_SET),
-                MakeEnumAccessor<WifiTidToLinkMappingNegSupport>(
-                    &EhtConfiguration::m_tidLinkMappingSupport),
-                MakeEnumChecker(
-                    WifiTidToLinkMappingNegSupport::WIFI_TID_TO_LINK_MAPPING_NOT_SUPPORTED,
-                    "NOT_SUPPORTED",
-                    WifiTidToLinkMappingNegSupport::WIFI_TID_TO_LINK_MAPPING_SAME_LINK_SET,
-                    "SAME_LINK_SET",
-                    WifiTidToLinkMappingNegSupport::WIFI_TID_TO_LINK_MAPPING_ANY_LINK_SET,
-                    "ANY_LINK_SET"))
+            .AddAttribute("TidToLinkMappingNegSupport",
+                          "TID-to-Link Mapping Negotiation Support.",
+                          EnumValue(WifiTidToLinkMappingNegSupport::ANY_LINK_SET),
+                          MakeEnumAccessor<WifiTidToLinkMappingNegSupport>(
+                              &EhtConfiguration::m_tidLinkMappingSupport),
+                          MakeEnumChecker(WifiTidToLinkMappingNegSupport::NOT_SUPPORTED,
+                                          "NOT_SUPPORTED",
+                                          WifiTidToLinkMappingNegSupport::SAME_LINK_SET,
+                                          "SAME_LINK_SET",
+                                          WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
+                                          "ANY_LINK_SET"))
             .AddAttribute(
                 "TidToLinkMappingDl",
                 "A list-of-TIDs-indexed map of the list of links where the TIDs are mapped to "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/eht/eht-configuration.h ns-3.42/src/wifi/model/eht/eht-configuration.h
--- ns-3.41/src/wifi/model/eht/eht-configuration.h	2024-02-09 14:44:08.581795000 -0800
+++ ns-3.42/src/wifi/model/eht/eht-configuration.h	2024-05-29 15:29:47.200073700 -0700
@@ -21,6 +21,7 @@
 #ifndef EHT_CONFIGURATION_H
 #define EHT_CONFIGURATION_H
 
+#include "ns3/deprecated.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/wifi-utils.h"
@@ -43,13 +44,32 @@
 /**
  * \brief TID-to-Link Mapping Negotiation Support
  */
-enum WifiTidToLinkMappingNegSupport : uint8_t
+enum class WifiTidToLinkMappingNegSupport : uint8_t
 {
-    WIFI_TID_TO_LINK_MAPPING_NOT_SUPPORTED = 0,
-    WIFI_TID_TO_LINK_MAPPING_SAME_LINK_SET = 1,
-    WIFI_TID_TO_LINK_MAPPING_ANY_LINK_SET = 3
+    NOT_SUPPORTED = 0,
+    SAME_LINK_SET = 1,
+    ANY_LINK_SET = 3
 };
 
+NS_DEPRECATED_3_42("Use WifiTidToLinkMappingNegSupport::NOT_SUPPORTED instead")
+static constexpr auto WIFI_TID_TO_LINK_MAPPING_NOT_SUPPORTED = WifiTidToLinkMappingNegSupport::
+    NOT_SUPPORTED; //!< \deprecated See WifiTidToLinkMappingNegSupport::NOT_SUPPORTED
+NS_DEPRECATED_3_42("Use WifiTidToLinkMappingNegSupport::SAME_LINK_SET instead")
+static constexpr auto WIFI_TID_TO_LINK_MAPPING_SAME_LINK_SET = WifiTidToLinkMappingNegSupport::
+    SAME_LINK_SET; //!< \deprecated See WifiTidToLinkMappingNegSupport::SAME_LINK_SET
+NS_DEPRECATED_3_42("Use WifiTidToLinkMappingNegSupport::ANY_LINK_SET instead")
+static constexpr auto WIFI_TID_TO_LINK_MAPPING_ANY_LINK_SET =
+    WifiTidToLinkMappingNegSupport::ANY_LINK_SET; //!< \deprecated See
+                                                  //!< WifiTidToLinkMappingNegSupport::ANY_LINK_SET
+
+/**
+ * \brief Stream insertion operator.
+ * \param [in] os The reference to the output stream.
+ * \param [in] negsupport The WifiTidToLinkMappingNegSupport.
+ * \return The reference to the output stream.
+ */
+std::ostream& operator<<(std::ostream& os, WifiTidToLinkMappingNegSupport negsupport);
+
 /**
  * \brief EHT configuration
  * \ingroup wifi
